import java.io.File;
import java.io.FileInputStream;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

import oracle.jdbc.OracleResultSet;

public class Main {
  public static void main(String[] args) throws Exception {
    Connection conn = getOracleConnection();
    int rows = 0;
    FileInputStream fin = null;
    OutputStream out = null;
    ResultSet rs = null;
    Statement stmt = null;
    oracle.sql.BLOB photo = null;
    conn.setAutoCommit(false);
    stmt = conn.createStatement();
    String id = "001";
    String binaryFileName = "fileName.dat";

    rows = stmt.executeUpdate("insert into my_pictures(id, photo ) values ('" + id
        + "', empty_blob() )");
    System.out.println(rows + " rows inserted");

    rs = stmt.executeQuery("select photo from  my_pictures where id = '" + id
        + "' for update nowait");
    rs.next();
    photo = ((OracleResultSet) rs).getBLOB(1);

    fin = new FileInputStream(new File(binaryFileName));
    out = photo.getBinaryOutputStream();
    // Get the optimal buffer size from the BLOB
    byte[] buffer = new byte[photo.getBufferSize()];
    int length = 0;
    while ((length = fin.read(buffer)) != -1) {
      out.write(buffer, 0, length);
    }
    conn.commit();

    out.close();
    fin.close();
    rs.close();
    stmt.close();
    conn.close();

  }

  private static Connection getHSQLConnection() throws Exception {
    Class.forName("org.hsqldb.jdbcDriver");
    System.out.println("Driver Loaded.");
    String url = "jdbc:hsqldb:data/tutorial";
    return DriverManager.getConnection(url, "sa", "");
  }

  public static Connection getMySqlConnection() throws Exception {
    String driver = "org.gjt.mm.mysql.Driver";
    String url = "jdbc:mysql://localhost/demo2s";
    String username = "oost";
    String password = "oost";

    Class.forName(driver);
    Connection conn = DriverManager.getConnection(url, username, password);
    return conn;
  }

  public static Connection getOracleConnection() throws Exception {
    String driver = "oracle.jdbc.driver.OracleDriver";
    String url = "jdbc:oracle:thin:@localhost:1521:databaseName";
    String username = "userName";
    String password = "password";

    Class.forName(driver); // load Oracle driver
    Connection conn = DriverManager.getConnection(url, username, password);
    return conn;
  }

}
